-- Non-Focus-Selection
-- Author: Valentin Schmidt
-- Version: 0.1

-- A little Lua hack for SciTE, to be loaded on startup e.g. via Extman.
-- It keeps text selections visible also when the SciTE window loses focus.

require 'winapiex'

-- constants
local WM_ACTIVATEAPP = 28

-- find SciTE window
local SciTEWindow = winapiex.getActiveWindow()
if SciTEWindow==0 then os.exit(1) end

-- @callback
function slotActivateApp (hwnd, uMsg, wParam, lParam)
  -- block WM_ACTIVATEAPP messages if wParam==0
  return wParam==0
end

-- start listening for WM_ACTIVATEAPP messages sent to SciTEWindow
winapiex.msgListen(SciTEWindow, {WM_ACTIVATEAPP}, 'slotActivateApp')
